//module for input and output functions
#include "cio.h"
#include <string.h>
#include <stdio.h>


//function for erase the screen
void cls(void)
{
  putchar(0x1b);
  putchar(0x45);
}



//function for read a vram address
char vpeek(int address)
{
__asm
push ix
ld ix,#0x00
add ix,sp
ld l,4(ix)
ld h,5(ix)
call 0x004a ;BIOS call for read a VRAM value 004AH RDVRM 07D7H Read byte from VRAM
ld h,#0x00
ld l,a
pop ix
__endasm;
}

//function for write a vram address
void vpoke(int address, char value)
{
__asm
push ix
ld ix,#0x00
add ix,sp
ld l,4(ix)
ld h,5(ix)
ld a,6(ix)
call 0x004d ;BIOS call for write a VRAM value 004DH WRTVRM 07CDH Write byte to VRAM
pop ix
__endasm;
}


//function for write a character in the screen
void putchar(char chr)
{
__asm
push ix
ld ix,#0x00
add ix,sp
ld a, 4(ix) ;reg for display the character
call 0x00A2 ;BIOS call for display the character
pop ix
__endasm;
}

//function for print a string in the screen
void print(char *string)
{
while( *string )
{
putchar( *string++ );
}
}

//function for read one caracter from the keyboard
char inkey(void)
{
__asm
push af
call 0x009F ;BIOS call to read a keyboard character
ld h,#0x00
ld l,a ;reg to put a readed character
pop af
__endasm;
}

//function for put the cursor in the x and y coordinates
void locate(char x,char y)
{
__asm
push ix
ld ix,#0x00
add ix,sp
ld l,4(ix) ;put the coordinate x in the reg l
ld h,5(ix) ;put the coordinata y in the reg h
call 0x00C6 ;BIOS call to move the cursore
pop ix
__endasm;
}




//function for move only the row position in the screen
void tab(char x)
{
   __asm
    ld l, 4(ix)  ;put the x coordinate in the reg l
    call 0x00C6 ;BIOS call for move the cursore
   __endasm;
}

//function for input one caracter with eco
void input(char var)
{
    var=inkey();
    putchar(var);
}

