
#include "graphic.h"
#include <math.h>

#define T32COL 0xF3BF
#define T32CGP 0xF3C1
#define T32ATR 0xF3C3
#define T32PAT 0xF3C5
#define T32NAM 0xF3BD

//it need to declare a line()'s global variables here because the stack for line() can't take them
//declare that variables below also as extern in app.c for the line()

int x, y, x1, x2, y1, y2, col;
float m, q;

//declare that variables below also as extern in app.c for the circle()
int a, b, ray, col;
float an, xp, yp;
float dpi=6.28, stp=6.28/800;

//declare the variables for put_sprite() and spriteS()
char number, xpos, ypos, colore;
char spritesize;
unsigned char profile[8];
int mem;
int index=0;

void color(char fg, char bg, char bd){
  __asm

  ld hl, #0xf3e9
  ld a, 4(ix)
  ld (hl), a

  inc hl
  ld a,5(ix)
  ld (hl), a

  inc hl
  ld a,6(ix)
  ld (hl), a

  call #0x0062  ;BIOS call for change the color

  __endasm;
}



//function for draw a pixel
void pset(int y, int x, int c) __naked
{ //requires screen 8 flipped by bios, bios variable set to 8. or 5.

	__asm
	pop hl
	pop bc
	pop de
	dec sp
	pop af
	push af
	inc sp
	push de
	push bc
	push hl

	push af
	ld ix,#0x91 ;MAPXYC
	call 0x15F ;EXTROM
	pop af

	ld ix,#0x99 ;SETATR
	call 0x15F ;EXTROM

	ld ix,#0x9D ;SETC
	call 0x15F ;EXTROM
	ret
	__endasm;

}

//function for draw a line
void line(void)
{
    if(x1==x2)
        m=0.0;
    else
	      m = (y2-y1);
        m = m /(x2-x1);

	  q = m*x1;
	  q = y1-q;

    if(x1==x2)
    {
	            for(y=y1; y<=y2; y++)
	            {
                  x = x1;
	                pset(x, y, col);
              }
    }
    else
    {
              for(x=x1; x<=x2; x++)
	            {
                  y = (int)(m*x+q);
	                pset(x, y, col);
              }
    }
    if(x1>x2 && y1>y2)
    {
              for(x=x1; x>=x2; x--)
	            {
                  y = (int)(m*x+q);
	                pset(x, y, col);
              }
    }
}


//function for draw a circle
void circle(void)
{
     for(an=0; an<dpi; an+=stp)
     {
          xp = sinf(an);
          xp = xp * ray;
	        xp = xp + a;

          yp = cosf(an);
	        yp = yp * ray;
          yp = yp + b;

	        pset((int)xp, (int)yp, col);
     }
}




//function for set the mode screen
void screen(char scr) __naked
{
  //this is only for SCREEN 2,3,4,5,6,7 and 8
  __asm
	     pop hl
       pop bc
     	 push bc
       push hl
       ld a,c
       call 0x5f   ;BIOS call for change the SCREEN MODE
       call 0x00CC ; --- erase function keys
       ret

  __endasm;
}


//accessories functions for Z80
void vdp(int n)
{
     otir(0x99, 2, (char*)&n);
} //use address range 0x4000 for setting vram write mode


char in(char port) __naked {
	port;

	__asm
	pop hl
	pop bc
	push bc
	push hl
	in l,(c)
	ret
	__endasm;
}


void otir(char port, unsigned char count, char *p) __naked {
	p; port; count;

	__asm
	pop de
	pop bc
	pop hl
	push hl
	push bc
	push de
	otir
	ret
	__endasm;
}

//for MSX1 VDP , 29 cycles
void otir29(char port, unsigned char count, char *p) __naked {
	p; port; count;

	__asm
	pop de
	pop bc
	pop hl
	push hl
	push bc
	push de
00001$:
	outi
	jp nz,00001$
	ret
	__endasm;
}


void inir(char port, unsigned char count, char *p) __naked {
	p; port; count;

	__asm
	pop de
	pop bc
	pop hl
	push hl
	push bc
	push de
	inir
	ret
	__endasm;
}


void inir29(char port, unsigned char count, char *p) __naked {
	p; port; count;

	__asm
	pop de
	pop bc
	pop hl
	push hl
	push bc
	push de
00001$:
	ini
	jp nz,00001$
	ret
	__endasm;
}


void out(char port, char n) __naked {
	port; n;

	__asm
	pop hl
	pop bc
	push bc
	out (c),b
	jp (hl)
	__endasm;
}



char vpeek(int address){
  __asm
   ld l, 4(ix)
   ld h, 5(ix)
   call  0x004a
   ld h, #0x00
   ld l, a
  __endasm;
}

void vpoke(int address, char value){
  __asm

  ld l, 4(ix)
  ld h, 5(ix)
  ld a, 6(ix)
  call  #0x004d

  __endasm;
}

char peek(int address){
  __asm
    ld l, 4(ix)
    ld h, 5(ix)
    ld l, (hl)
    ld h, #0x00
  __endasm;
}

int peek_word(int address){
  return
    ((int)peek(address)&0xff) |
    (peek(address+1)<<8) ;
}

void poke(int address, char value){
  __asm
    ld l, 4(ix)
    ld h, 5(ix)
    ld a, 6(ix)
    ld (hl), a
  __endasm;
}





