
#include "sound.h"

/*function for put a value in PSG register*/
void sound(char reg, unsigned char val)
{
  di();
	out(0xa0,reg);
	out(0xa1,val);
	ei();
}

/*function for retrive a value of the register put in the first parameter*/
char get_PSG_REG(char reg)
{
 __asm
 ld a, 4(ix)
 out(0x00A0), a
 in a, (0x00A2)
 ld l, a
 __endasm;
}

//function for generate a beep
void beep(void){
    __asm
         call 0x00c0   ; ---> BIOS call for sound a beep
    __endasm;
}

void di() __naked {
	__asm
	di
	ret
	__endasm;
}


void ei() __naked {
	__asm
	ei
	ret
	__endasm;
}


void halt() __naked {
	__asm
	halt
	ret
	__endasm;
}


void out(char port, char n) __naked {
	port; n;

	__asm
	pop hl
	pop bc
	push bc
	out (c),b
	jp (hl)
	__endasm;
}




